/*
  This file is part of GerQUtils.

  GerQUtils is free software: you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation, either version 3 of the License, or (at your option) any later
  version.

  GerQUtils is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  GerQUtils.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef GERQ_ASSOADAPTER_H
#define GERQ_ASSOADAPTER_H


#include "gerqutilsbase.h"
#include "dataobject.h"
#include <QHash>
#include <QString>


namespace GerQ {


  typedef QHash<QString, QString> AssoIDs;
  typedef QHash<QString, QString>::iterator AssoIDIterator;


  class AssoAdapter {

    public:

      virtual void getYinIDs(DataObject *aYan, AssoIDs &aIDs) = ABSTRACT;
      virtual void getYanIDs(DataObject *aYin, AssoIDs &aIDs) = ABSTRACT;

      virtual void insertAssociation(
        DataObject *aYin, DataObject* aYan) = ABSTRACT;
      virtual void deleteAssociation(
        DataObject *aYin, DataObject* aYan) = ABSTRACT;

  }; // AssoAdapter


} // GerQ


#endif
