/*
  This file is part of GerQUtils.

  GerQUtils is free software: you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation, either version 3 of the License, or (at your option) any later
  version.

  GerQUtils is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  GerQUtils.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef GERQ_DATAADAPTER_H
#define GERQ_DATAADAPTER_H


#include "gerqutilsbase.h"

#include <QList>
#include <QVariant>


namespace GerQ {


  class DataAdapter {

    public:

      DataAdapter();
      virtual ~DataAdapter();

      DataContainer *getContainer();

      virtual void reload() = ABSTRACT;
      virtual void readAllIDs(QList<QVariant> &aIDs) = ABSTRACT;

      virtual void newData(QVariant &aID) = ABSTRACT;
      virtual bool read(DataObject *aData) = ABSTRACT;
      virtual void write(DataObject *aData) = ABSTRACT;
      virtual void erase(DataObject *aData ) = ABSTRACT;

    private:

      friend class DataContainer;
      DataContainer *fContainer;

  }; // DataAdapter


} // GerQ


#endif
