/*
  This file is part of GerQUtils.

  GerQUtils is free software: you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation, either version 3 of the License, or (at your option) any later
  version.

  GerQUtils is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  GerQUtils.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef GERQ_DEFAULTSQLDATAADAPTER_H
#define GERQ_DEFAULTSQLDATAADAPTER_H


#include "gerqutilsbase.h"

#include "sqldataadapter.h"


namespace GerQ {


  class DefaultSqlDataAdapter: public SqlDataAdapter {

    public:

      DefaultSqlDataAdapter(
        const QString &aTableName, const QString &aIDColumn,
        void (*aRead)(DataObject*, SqlDataAdapter*),
	void (*aWrite)(DataObject*, SqlDataAdapter*));

      virtual void newData(QVariant &aID);

    protected:

      virtual void doRead(DataObject *aData, SqlDataAdapter *aSql);
      virtual void doWrite(DataObject *aData, SqlDataAdapter *aSql);

    private:

      void (*fRead)(DataObject*, SqlDataAdapter*);
      void (*fWrite)(DataObject*, SqlDataAdapter*);

  }; // DefaultSqlDataAdapter


} // GerQ


#endif
