/*
  This file is part of GerQUtils.

  GerQUtils is free software: you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation, either version 3 of the License, or (at your option) any later
  version.

  GerQUtils is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  GerQUtils.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef GERQ_GERQUTILSBASE_H
#define GERQ_GERQUTILSBASE_H


#include <exception>
#include <iostream>


#define __NO_ERROR__ "GERQ: NO ERROR"


namespace GerQ {

  class DataObject;
  class DataContainer;
    class InstContainer;
      class DefaultInstContainer;
    class RefContainer;
      class DefaultRefContainer;
  class DataAdapter;
    class SqlDataAdapter;
      class DefaultSqlDataAdapter;
  class Associator;
    class DefaultAssociator;
  class AssoAdapter;
    class DefaultSqlAssoAdapter;

  class no_error: public std::exception {
    public:
      virtual const char* what() const throw() { return __NO_ERROR__; };
  }; // no_error

} // GerQ


#define ABSTRACT 0;

#define FINALLY throw GerQ::no_error(); } catch (std::exception &exc) { if(strcmp(exc.what(), __NO_ERROR__) != 0) throw exc;


#endif
